package com.syjy.calculate.conotroller;

import com.syjy.calculate.entity.CalculationFormula;
import com.syjy.calculate.repository.CalculationFormulaRepository;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;
import java.util.List;

/**
 * 公式管理
 *
 * @author zcl
 * @version 1.0
 * @since 2022/8/8 9:30
 */
@Controller
@RequestMapping("calculateView/jarCalculate")
public class JarCalculate {
    @Autowired
    CalculationFormulaRepository calculationFormulaRepository;

    /**
     * 查询所有公式
     * @return
     */
    @GetMapping("select")
    @ResponseBody
    public List<CalculationFormula> select() {
        return calculationFormulaRepository.select();
    }

    /**
     * 更新公式
     * @param calculationFormula
     * @return
     */
    @PostMapping("edit")
    @ResponseBody
    public String edit(@RequestBody CalculationFormula calculationFormula) {
        if(calculationFormulaRepository.update(calculationFormula)==0){
            return "修改失败";
        }
        return "修改成功";
    }

    /**
     * 新增公式
     * @param calculationFormula
     * @return
     */
    @PostMapping("add")
    @ResponseBody
    public String add(@RequestBody CalculationFormula calculationFormula) {
        if(calculationFormulaRepository.add(calculationFormula)==0){
            return "新增失败";
        }
        return "新增成功";
    }

    @PostMapping("delete")
    @ResponseBody
    public String delete(@RequestBody CalculationFormula calculationFormula) {
        Integer id = calculationFormula.getId();
        if(calculationFormulaRepository.delete(id)==0){
            return "删除失败";
        }
        return "删除成功";
    }
}
