package com.syjy.calculate.function;

import com.googlecode.aviator.AviatorEvaluator;
import com.googlecode.aviator.runtime.RuntimeUtils;
import com.googlecode.aviator.runtime.type.Sequence;
import java.math.BigDecimal;
import java.util.Map;

/**
 * 公式通用工具
 *
 * @author zcl
 * @version 1.0
 * @since 2022/9/8 9:30
 */
public class CommonUtil {
    public static Sequence getSeq(Object obj, final Map<String, Object> env){
        if (obj == null) {
            throw new NullPointerException("null seq");
        }
        // 将参数放入抽象集合中
        Sequence seq = RuntimeUtils.seq(obj, env);
        return seq;
    }

    /**
     * 根据集合循环公式求和
     * @param exp
     * @param seq
     * @return
     */
    public static BigDecimal sum(String exp,Sequence seq){
        BigDecimal sum = BigDecimal.ZERO;
        for (Object obj : seq) {
            Map<String, Object> map = (Map<String, Object>) obj;
            // 计算: (实际-预测)的平方
            BigDecimal forResult = new BigDecimal(String.valueOf( AviatorEvaluator.execute(exp,map)));
            // 求和
            sum = sum.add(forResult);
        }
        return sum;
    }

    /**
     * 校验参数是否为空
     * @param paramOne
     * @param paramTwo
     * @return
     */
    public static boolean checkParam(Object paramOne,Object paramTwo,Object paramThree){
        if(paramOne==null || paramTwo==null || paramThree == null ){
            return false;
        }
        return true;
    }

}
