package com.syjy.calculate.function;

import com.googlecode.aviator.runtime.function.AbstractFunction;
import com.googlecode.aviator.runtime.type.AviatorDecimal;
import com.googlecode.aviator.runtime.type.AviatorJavaType;
import com.googlecode.aviator.runtime.type.AviatorObject;
import com.googlecode.aviator.runtime.type.Sequence;
import java.math.BigDecimal;
import java.util.Map;

/**
 * 计算两个数的差值的绝对值并求和：Σ|实际-预测|
 *
 * @author zcl
 * @version 1.0
 * @since 2022/9/8 9:30
 */
public class SumDifferenceAbsolute extends AbstractFunction {
    @Override
    public AviatorObject call(Map<String, Object> env, AviatorObject arg1, AviatorObject arg2, AviatorObject arg3) {
        Object first = arg1.getValue(env);
        String second = ((AviatorJavaType) arg2).getName();
        String third = ((AviatorJavaType) arg3).getName();
        // 将参数转为集合
        Sequence seq = CommonUtil.getSeq(first, env);
        BigDecimal sum;
        // 拼接表达式
        String exp = "differenceAbsolute(" + second + "," + third + ")";
        sum = CommonUtil.sum(exp, seq);
        return new AviatorDecimal(sum);
    }

    @Override
    public String getName() {
        return "sumDifferenceAbsolute";
    }
}
