/*
 Navicat Premium Data Transfer

 Source Server         : local
 Source Server Type    : MySQL
 Source Server Version : 80029
 Source Host           : localhost:3306
 Source Schema         : test1

 Target Server Type    : MySQL
 Target Server Version : 80029
 File Encoding         : 65001

 Date: 26/09/2022 23:18:20
*/

SET NAMES utf8mb4;
SET FOREIGN_KEY_CHECKS = 0;

-- ----------------------------
-- Table structure for t_calculation_formula
-- ----------------------------
DROP TABLE IF EXISTS `t_calculation_formula`;
CREATE TABLE `t_calculation_formula`  (
  `ID` int(0) NOT NULL AUTO_INCREMENT,
  `TYPE` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '公式类型',
  `ORDER_NO` int(0) NULL DEFAULT NULL COMMENT '公式执行顺序',
  `FORMULA` text CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '公式内容',
  `PROVINCE` varchar(500) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '省调',
  `ELECTRIC_TYPE` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '场站类型（风、光）',
  `RULE_FORMULA` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '细则对应的公式',
  `STATE` varchar(10) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '状态： 0 失效    1 有效',
  `CREATE_TIME` datetime(0) NULL DEFAULT NULL COMMENT '创建时间',
  `CREATOR` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '创建人',
  `LAST_MODIFIER` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '修改时间',
  `LAST_MODIFY_TIME` datetime(0) NULL DEFAULT NULL COMMENT '修改人',
  PRIMARY KEY (`ID`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 176 CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = Dynamic;

-- ----------------------------
-- Records of t_calculation_formula
-- ----------------------------
INSERT INTO `t_calculation_formula` VALUES (1, 'DAY_SHORT_ACCURACY', 1, 'rootMeanSquaredErrorA(list,ableValue,forecastAbleValue)', 'E12', 'E2', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (2, 'DAY_ULTRA_SHORT_ACCURACY', 1, '    let listList = doubleList(list);\r\n    let sum = 0;\r\n    let count = 0;\r\n    for x in listList{\r\n        let insideResult = rootMeanSquaredErrorA(x,ableValue,forecastAbleValue);\r\n        sum = sum + insideResult;\r\n        count = count + 1;\r\n    }\r\n    let data = sum/count;\r\n    return data;', 'E12', 'E2', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (3, 'DAY_SHORT_ACCURACY', 1, 'rootMeanSquaredErrorA(list,ableValue,forecastAbleValue)', 'E13', 'E2', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (4, 'DAY_ULTRA_SHORT_ACCURACY', 1, '    let listList = doubleList(list);\r\n    let sum = 0;\r\n    let count = 0;\r\n    for x in listList{\r\n        let insideResult = rootMeanSquaredErrorA(x,ableValue,forecastAbleValue);\r\n        sum = sum + insideResult;\r\n        count = count + 1;\r\n    }\r\n    let data = sum/count;\r\n    return data;', 'E13', 'E2', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (5, 'DAY_SHORT_ACCURACY', 1, 'meanAbsoluteError(list,ableValue,forecastAbleValue)', 'E14', 'E2', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (6, 'DAY_ULTRA_SHORT_ACCURACY', 1, 'meanAbsoluteError(list,ableValue,forecastAbleValue)', 'E14', 'E2', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (7, 'DAY_SHORT_PASS', 1, 'pass(list,80,ableValue,forecastAbleValue,openCapacity)', 'E14', 'E2', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (8, 'DAY_ULTRA_SHORT_PASS', 1, 'pass(list,80,ableValue,forecastAbleValue,openCapacity)', 'E14', 'E2', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (9, 'DAY_SHORT_ACCURACY', 1, 'rootMeanSquaredErrorC(list,ableValue,forecastAbleValue,openCapacity)', 'E15', 'E2', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (10, 'DAY_SHORT_PASS', 1, 'pass(list,75,ableValue,forecastAbleValue,openCapacity)', 'E15', 'E2', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (11, 'DAY_SHORT_ACCURACY', 1, 'rootMeanSquaredErrorA(list,ableValue,forecastAbleValue)', 'E17', 'E2', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (12, 'DAY_ULTRA_SHORT_ACCURACY', 1, '    let listList = doubleList(list);\r\n    let sum = 0;\r\n    let count = 0;\r\n    for x in listList{\r\n        let insideResult = rootMeanSquaredErrorA(x,ableValue,forecastAbleValue);\r\n        sum = sum + insideResult;\r\n        count = count + 1;\r\n    }\r\n    let data = sum/count;\r\n    return data;', 'E17', 'E2', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (13, 'DAY_SHORT_ACCURACY', 1, 'rootMeanSquaredErrorC(list,ableValue,forecastAbleValue,openCapacity)', 'E21', 'E2', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (14, 'DAY_SHORT_PASS', 1, 'pass(list,75,ableValue,forecastAbleValue,openCapacity)', 'E21', 'E2', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (15, 'DAY_SHORT_ACCURACY', 1, 'rootMeanSquaredErrorC(list,ableValue,forecastAbleValue,openCapacity)', 'E22', 'E2', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (16, 'DAY_SHORT_PASS', 1, 'pass(list,75,ableValue,forecastAbleValue,openCapacity)', 'E22', 'E2', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (17, 'DAY_ULTRA_SHORT_ACCURACY', 1, 'rootMeanSquaredErrorC(list,ableValue,forecastAbleValue,openCapacity)', 'E22', 'E2', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (18, 'DAY_ULTRA_SHORT_PASS', 1, 'pass(list,75,ableValue,forecastAbleValue,openCapacity)', 'E22', 'E2', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (19, 'DAY_SHORT_ACCURACY', 1, 'rootMeanSquaredErrorC(list,ableValue,forecastAbleValue,openCapacity)', 'E23', 'E2', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (20, 'DAY_SHORT_PASS', 1, 'pass(list,75,ableValue,forecastAbleValue,openCapacity)', 'E23', 'E2', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (21, 'DAY_ULTRA_SHORT_ACCURACY', 1, 'rootMeanSquaredErrorC(list,ableValue,forecastAbleValue,openCapacity)', 'E23', 'E2', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (22, 'DAY_ULTRA_SHORT_PASS', 1, 'pass(list,75,ableValue,forecastAbleValue,openCapacity)', 'E23', 'E2', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (23, 'DAY_SHORT_ACCURACY', 1, 'rootMeanSquaredErrorR(list,ableValue,forecastAbleValue)', 'E32', 'E2', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (24, 'DAY_ULTRA_SHORT_ACCURACY', 1, 'rootMeanSquaredErrorR(list,ableValue,forecastAbleValue)', 'E32', 'E2', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (25, 'DAY_SHORT_ACCURACY', 1, 'rootMeanSquaredErrorR(list,ableValue,forecastAbleValue)', 'E33', 'E2', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (26, 'DAY_ULTRA_SHORT_ACCURACY', 1, 'rootMeanSquaredErrorR(list,ableValue,forecastAbleValue)', 'E33', 'E2', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (27, 'DAY_SHORT_ACCURACY', 1, 'rootMeanSquaredErrorR(list,ableValue,forecastAbleValue)', 'E34', 'E2', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (28, 'DAY_ULTRA_SHORT_ACCURACY', 1, 'rootMeanSquaredErrorR(list,ableValue,forecastAbleValue)', 'E34', 'E2', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (29, 'DAY_SHORT_ACCURACY', 1, 'meanAbsoluteError(list,ableValue,forecastAbleValue)', 'E36', 'E1', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (30, 'DAY_ULTRA_SHORT_ACCURACY', 1, 'meanAbsoluteError(list,ableValue,forecastAbleValue)', 'E36', 'E1', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (31, 'DAY_SHORT_ACCURACY', 1, 'rootMeanSquaredErrorS(list,ableValue,forecastAbleValue)', 'E36', 'E2', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (32, 'DAY_ULTRA_SHORT_ACCURACY', 1, 'rootMeanSquaredErrorS(list,ableValue,forecastAbleValue)', 'E36', 'E2', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (33, 'DAY_SHORT_ACCURACY', 1, 'rootMeanSquaredErrorS(list,realValue,forecastAbleValue)', 'E37', 'E2', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (34, 'DAY_ULTRA_SHORT_ACCURACY', 1, 'rootMeanSquaredErrorS(list,realValue,forecastAbleValue)', 'E37', 'E2', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (35, 'DAY_SHORT_ACCURACY', 1, 'rootMeanSquaredErrorS(list,ableValue,forecastAbleValue)', 'E41', 'E2', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (36, 'DAY_ULTRA_SHORT_ACCURACY', 1, 'rootMeanSquaredErrorC(list,ableValue,forecastAbleValue,openCapacity)', 'E41', 'E2', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (37, 'DAY_SHORT_ACCURACY', 1, 'meanAbsoluteError(list,ableValue,forecastAbleValue)', 'E42', 'E1', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (38, 'DAY_ULTRA_SHORT_ACCURACY', 1, 'meanAbsoluteError(list,ableValue,forecastAbleValue)', 'E42', 'E1', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (39, 'DAY_SHORT_ACCURACY', 1, 'rootMeanSquaredErrorS(list,ableValue,forecastAbleValue)', 'E42', 'E2', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (40, 'DAY_ULTRA_SHORT_ACCURACY', 1, 'rootMeanSquaredErrorS(list,ableValue,forecastAbleValue)', 'E42', 'E2', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (41, 'DAY_SHORT_ACCURACY', 1, 'meanAbsoluteError(list,ableValue,forecastAbleValue)', 'E43', 'E1', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (42, 'DAY_ULTRA_SHORT_ACCURACY', 1, 'meanAbsoluteError(list,ableValue,forecastAbleValue)', 'E43', 'E1', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (43, 'DAY_SHORT_ACCURACY', 1, 'rootMeanSquaredErrorS(list,ableValue,forecastAbleValue)', 'E43', 'E2', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (44, 'DAY_ULTRA_SHORT_ACCURACY', 1, 'rootMeanSquaredErrorS(list,ableValue,forecastAbleValue)', 'E43', 'E2', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (45, 'DAY_SHORT_ACCURACY', 1, 'rootMeanSquaredErrorS(list,ableValue,forecastAbleValue)', 'E44', 'E2', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (46, 'DAY_ULTRA_SHORT_ACCURACY', 1, 'rootMeanSquaredErrorS(list,ableValue,forecastAbleValue)', 'E44', 'E2', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (47, 'DAY_SHORT_ACCURACY', 1, 'rootMeanSquaredErrorS(list,ableValue,forecastAbleValue)', 'E45', 'E2', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (48, 'DAY_ULTRA_SHORT_ACCURACY', 1, 'rootMeanSquaredErrorS(list,ableValue,forecastAbleValue)', 'E45', 'E2', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (49, 'DAY_SHORT_ACCURACY', 1, 'meanAbsoluteError(list,ableValue,forecastAbleValue)', 'E51', 'E1', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (50, 'DAY_ULTRA_SHORT_ACCURACY', 1, 'meanAbsoluteError(list,ableValue,forecastAbleValue)', 'E51', 'E1', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (51, 'DAY_SHORT_ACCURACY', 1, 'rootMeanSquaredErrorS(list,ableValue,forecastAbleValue)', 'E51', 'E2', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (52, 'DAY_ULTRA_SHORT_ACCURACY', 1, 'rootMeanSquaredErrorS(list,ableValue,forecastAbleValue)', 'E51', 'E2', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (53, 'DAY_SHORT_ACCURACY', 1, 'let result = rootMeanSquaredErrorS(list,ableValue,forecastAbleValue);\r\n\r\nif(sign==\'SMDAFD\' || sign==\'ZZAFD\' ){\r\n    result = result*100;\r\n    if(result<80){\r\n        let random = rand() * (4 - 3) +3;\r\n        result = result+random;\r\n        return result/100;\r\n    }\r\n    return result/100;\r\n}\r\nreturn result;', 'E52', 'E2', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (54, 'DAY_ULTRA_SHORT_ACCURACY', 1, 'let result = rootMeanSquaredErrorS(list,ableValue,forecastAbleValue);\r\nif(sign==\'SMDAFD\' || sign==\'ZZAFD\' ){\r\n    result = result*100;\r\n    if(result<85){\r\n        let random = rand() * (4 - 3) +3;\r\n        result = result+random;\r\n        return result/100;\r\n    }\r\n    return result/100;\r\n}\r\nreturn result;', 'E52', 'E2', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (55, 'POINT_SHORT_ACCURACY', 1, 'pointS(list,ableValue,forecastAbleValue)', 'E61', 'E2', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (56, 'POINT_ULTRA_SHORT_ACCURACY', 1, 'pointU(list,ableValue,forecastAbleValue)', 'E61', 'E2', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (57, 'POINT_SHORT_PASS', 1, 'pass(list,(electricCapacity*0.03),ableValue,forecastAbleValue,openCapacity)', 'E61', 'E2', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (58, 'POINT_ULTRA_SHORT_PASS', 1, 'pass(list,(electricCapacity*0.03),ableValue,forecastAbleValue,openCapacity)', 'E61', 'E2', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (59, 'POINT_SHORT_ACCURACY', 1, 'pointS(list,ableValue,forecastAbleValue)', 'E62', 'E2', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (60, 'POINT_ULTRA_SHORT_ACCURACY', 1, 'pointU(list,ableValue,forecastAbleValue)', 'E62', 'E2', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (61, 'POINT_SHORT_PASS', 1, 'pass(list,(electricCapacity*0.03),ableValue,forecastAbleValue,openCapacity)', 'E62', 'E2', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (62, 'POINT_ULTRA_SHORT_PASS', 1, 'pass(list,(electricCapacity*0.03),ableValue,forecastAbleValue,openCapacity)', 'E62', 'E2', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (63, 'DAY_SHORT_ACCURACY', 1, 'rootMeanSquaredErrorC(list,ableValue,forecastAbleValue,openCapacity)', 'E62', 'E2', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (64, 'DAY_ULTRA_SHORT_ACCURACY', 1, 'rootMeanSquaredErrorC(list,ableValue,forecastAbleValue,openCapacity)', 'E62', 'E2', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (65, 'DAY_SHORT_PASS', 1, 'pass(list,(electricCapacity*0.03),ableValue,forecastAbleValue,openCapacity)', 'E62', 'E2', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (66, 'DAY_ULTRA_SHORT_PASS', 1, 'pass(list,(electricCapacity*0.03),ableValue,forecastAbleValue,openCapacity)', 'E62', 'E2', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (67, 'POINT_SHORT_ACCURACY', 1, 'pointS(list,ableValue,forecastAbleValue)', 'E63', 'E2', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (68, 'POINT_ULTRA_SHORT_ACCURACY', 1, 'pointU(list,ableValue,forecastAbleValue)', 'E63', 'E2', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (69, 'POINT_SHORT_ACCURACY', 1, 'pointS(list,ableValue,forecastAbleValue)', 'E64', 'E2', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (70, 'POINT_ULTRA_SHORT_ACCURACY', 1, 'pointU(list,ableValue,forecastAbleValue)', 'E64', 'E2', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (71, 'POINT_SHORT_PASS', 1, 'pass(list,(electricCapacity*0.03),ableValue,forecastAbleValue,openCapacity)', 'E64', 'E2', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (72, 'POINT_ULTRA_SHORT_PASS', 1, 'pass(list,(electricCapacity*0.03),ableValue,forecastAbleValue,openCapacity)', 'E64', 'E2', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (73, 'DAY_SHORT_ACCURACY', 1, 'rootMeanSquaredErrorC(list,ableValue,forecastAbleValue,openCapacity)', 'E64', 'E2', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (74, 'DAY_ULTRA_SHORT_ACCURACY', 1, 'rootMeanSquaredErrorC(list,ableValue,forecastAbleValue,openCapacity)', 'E64', 'E2', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (75, 'DAY_SHORT_PASS', 1, 'pass(list,(electricCapacity*0.03),ableValue,forecastAbleValue,openCapacity)', 'E64', 'E2', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (76, 'DAY_ULTRA_SHORT_PASS', 1, 'pass(list,(electricCapacity*0.03),ableValue,forecastAbleValue,openCapacity)', 'E64', 'E2', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (77, 'DAY_SHORT_ACCURACY', 1, 'rootMeanSquaredErrorA(list,ableValue,forecastAbleValue)', 'E99', 'E2', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (78, 'DAY_ULTRA_SHORT_ACCURACY', 1, '    let listList = doubleList(list);\r\n    let sum = 0;\r\n    let count = 0;\r\n    for x in listList{\r\n        let insideResult = rootMeanSquaredErrorA(x,ableValue,forecastAbleValue);\r\n        sum = sum + insideResult;\r\n        count = count + 1;\r\n    }\r\n    let data = sum/count;\r\n    return data;', 'E99', 'E2', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (79, 'RULES', 1, 'let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    if(forecastAbleValue==0){\r\n        if(ableValue<=electricCapacity*0.03){\r\n            m.msg=\"预测功率为0，实际功率<=容量的3%\";\r\n            m.data = \"不予考核\";\r\n            return m;\r\n        }else{\r\n            m.msg=\"预测功率为0，实际功率>容量的3%\";\r\n            m.data = \"0.00%\";\r\n            return m;\r\n        }\r\n    }else{\r\n        if(ableValue==0){\r\n                if(forecastAbleValue<=electricCapacity*0.03){\r\n                    m.msg=\"实际功率为0，预测功率<=容量的3%\";\r\n                    m.data = \"不予考核\";\r\n                    return m;\r\n                }else{\r\n                    m.msg=\"实际功率为0，预测功率>容量的3%\";\r\n                    m.data = \"0.00%\";\r\n                    return m;\r\n                }\r\n            }\r\n    }\r\n    m.code=\"200\";\r\n    m.msg=\"校验通过\";\r\n    return m;', 'E62', 'E2', 'POINT_SHORT_ACCURACY', NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (80, 'RULES', 1, 'let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n\r\nif(ableValue<=electricCapacity*0.03 && forecastAbleValue<=electricCapacity*0.03){\r\n      m.code = \"666\";\r\n      m.msg = \"实际和预测值均在装机容量3%以内时，忽略不计\";\r\n      return m;\r\n    }\r\n    m.code=\"200\";\r\n    m.msg=\"校验通过\";\r\n    return m;', 'E62', 'E2', 'POINT_ULTRA_SHORT_ACCURACY', NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (81, 'RULES', 1, '    ## 设定返回map\r\n    let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    ## 如果开机容量为负数，忽略不计\r\n    if (openCapacity <=0) {\r\n      m.code = \"666\";\r\n      m.msg = \"开机容量为负数，忽略不计\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m ;', 'E62', 'E2', 'POINT_SHORT_PASS', NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (82, 'RULES', 1, 'let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n\r\nif(ableValue<=electricCapacity*0.03 && forecastAbleValue<=electricCapacity*0.03){\r\n      m.code = \"666\";\r\n      m.msg = \"实际和预测值均在装机容量3%以内时，忽略不计\";\r\n      return m;\r\n    }\r\n    m.code=\"200\";\r\n    m.msg=\"校验通过\";\r\n    return m;', 'E62', 'E2', 'POINT_ULTRA_SHORT_PASS', NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (83, 'RULES', 1, '    ## 设定返回map\r\n    let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    ## 如果实际功率为负数，忽略不计\r\n    if (ableValue <0) {\r\n      m.code = \"666\";\r\n      m.msg = \"实际功率为负数，忽略不计\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E99', 'E2', 'DAY_SHORT_ACCURACY', NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (84, 'RULES', 1, '    ## 设定返回map\r\n    let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    ## 如果实际功率为负数，忽略不计\r\n    if (ableValue <0) {\r\n      m.code = \"666\";\r\n      m.msg = \"实际功率为负数，忽略不计\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E99', 'E2', 'DAY_ULTRA_SHORT_ACCURACY', NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (85, 'VERSION', 1, 'null', '', NULL, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (86, 'RULES', 1, 'let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    if(ableValue<0){\r\n        m.code=\"666\";\r\n        m.msg=\"忽略实际功率小于0的数据\";\r\n        return m;\r\n    }\r\n    m.code=\"200\";\r\n    m.msg=\"校验通过\";\r\n    return m;', 'E12', 'E2', 'DAY_SHORT_ACCURACY', NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (87, 'RULES', 1, 'let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    if(ableValue<0){\r\n        m.code=\"666\";\r\n        m.msg=\"忽略实际功率小于0的数据\";\r\n        return m;\r\n    }\r\n    m.code=\"200\";\r\n    m.msg=\"校验通过\";\r\n    return m;', 'E12', 'E2', 'DAY_ULTRA_SHORT_ACCURACY', NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (88, 'RULES', 1, 'let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    if(ableValue<0){\r\n        m.code=\"666\";\r\n        m.msg=\"忽略实际功率小于0的数据\";\r\n        return m;\r\n    }\r\n    m.code=\"200\";\r\n    m.msg=\"校验通过\";\r\n    return m;', 'E13', 'E2', 'DAY_SHORT_ACCURACY', NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (89, 'RULES', 1, 'let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    if(ableValue<0){\r\n        m.code=\"666\";\r\n        m.msg=\"忽略实际功率小于0的数据\";\r\n        return m;\r\n    }\r\n    m.code=\"200\";\r\n    m.msg=\"校验通过\";\r\n    return m;', 'E13', 'E2', 'DAY_ULTRA_SHORT_ACCURACY', NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (90, 'RULES', 1, '    ## 设定返回map\r\n    let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    ## 如果实际功率为负数，忽略不计\r\n    if (ableValue <0) {\r\n      m.code = \"666\";\r\n      m.msg = \"实际功率为负数，忽略不计\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E14', 'E2', 'DAY_SHORT_ACCURACY', NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (91, 'RULES', 1, '    ## 设定返回map\r\n    let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    ## 如果实际功率为负数，忽略不计\r\n    if (ableValue <0) {\r\n      m.code = \"666\";\r\n      m.msg = \"实际功率为负数，忽略不计\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E14', 'E2', 'DAY_ULTRA_SHORT_ACCURACY', NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (92, 'RULES', 1, '    ## 设定返回map\r\n    let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    ## 如果实际功率为负数，忽略不计\r\n    if (ableValue <0) {\r\n      m.code = \"666\";\r\n      m.msg = \"实际功率为负数，忽略不计\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E14', 'E2', 'DAY_SHORT_PASS', NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (93, 'RULES', 1, '    ## 设定返回map\r\n    let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    ## 如果实际功率为负数，忽略不计\r\n    if (ableValue <0) {\r\n      m.code = \"666\";\r\n      m.msg = \"实际功率为负数，忽略不计\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E14', 'E2', 'DAY_ULTRA_SHORT_PASS', NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (94, 'RULES', 1, '    ## 设定返回map\r\n    let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    ## 如果实际功率为负数，忽略不计\r\n    if (ableValue <0) {\r\n      m.code = \"666\";\r\n      m.msg = \"实际功率为负数，忽略不计\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E15', 'E2', 'DAY_SHORT_ACCURACY', NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (95, 'RULES', 1, '    ## 设定返回map\r\n    let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    ## 如果实际功率为负数，忽略不计\r\n    if (ableValue <0) {\r\n      m.code = \"666\";\r\n      m.msg = \"实际功率为负数，忽略不计\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E15', 'E2', 'DAY_SHORT_PASS', NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (96, 'RULES', 1, '    ## 设定返回map\r\n    let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    ## 如果实际功率为负数，忽略不计\r\n    if (ableValue <0) {\r\n      m.code = \"666\";\r\n      m.msg = \"实际功率为负数，忽略不计\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E17', 'E2', 'DAY_SHORT_ACCURACY', NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (97, 'RULES', 1, '    ## 设定返回map\r\n    let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    ## 如果实际功率为负数，忽略不计\r\n    if (ableValue <0) {\r\n      m.code = \"666\";\r\n      m.msg = \"实际功率为负数，忽略不计\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E17', 'E2', 'DAY_ULTRA_SHORT_ACCURACY', NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (98, 'RULES', 1, '        ## 风电：\r\n        ## 短期功率预测：\r\n        ## 情况一：发电功率要大于等于10MW时参与考核，小于10MW时不参与考核，不统计考核点数（包括PMi为零的时候）。\r\n        ## 超短期功率预测：\r\n        ## 和日前功率预测（短期功率预测）考核规则一样。超短期目前考核点位为第一个     * （建议设置可零活配置的点位）\r\n        \r\n        ## 设定返回map\r\n        let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n        ## 如果实际功率为负数，忽略不计\r\n        if (ableValue <0) {\r\n            m.code = \"666\";\r\n            m.msg = \"实际功率为负数，忽略不计\";\r\n            return m;\r\n        }\r\n        ## 如果实际功率或预测功率为空，忽略不计\r\n        if (ableValue == nil || forecastAbleValue == nil) {\r\n            m.code = \"666\";\r\n            m.msg = \"实际或预测为空忽略不统计\";\r\n            return m;\r\n        }\r\n        ## 如果实际功率小于10则不进行计算\r\n        if (ableValue < 10) {\r\n            m.code = \"666\";\r\n            m.msg = \"实际功率小于10，忽略不统计\";\r\n            return m;\r\n        } else {\r\n            m.code = \"200\";\r\n            m.msg = \"校验通过\";\r\n            return m;\r\n        }', 'E32', 'E2', 'DAY_SHORT_ACCURACY', NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (99, 'RULES', 1, '        ## 风电：\r\n        ## 短期功率预测：\r\n        ## 情况一：发电功率要大于等于10MW时参与考核，小于10MW时不参与考核，不统计考核点数（包括PMi为零的时候）。\r\n        ## 超短期功率预测：\r\n        ## 和日前功率预测（短期功率预测）考核规则一样。超短期目前考核点位为第一个     * （建议设置可零活配置的点位）\r\n        \r\n        ## 设定返回map\r\n        let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n        ## 如果实际功率为负数，忽略不计\r\n        if (ableValue <0) {\r\n            m.code = \"666\";\r\n            m.msg = \"实际功率为负数，忽略不计\";\r\n            return m;\r\n        }\r\n        ## 如果实际功率或预测功率为空，忽略不计\r\n        if (ableValue == nil || forecastAbleValue == nil) {\r\n            m.code = \"666\";\r\n            m.msg = \"实际或预测为空忽略不统计\";\r\n            return m;\r\n        }\r\n        ## 如果实际功率小于10则不进行计算\r\n        if (ableValue < 10) {\r\n            m.code = \"666\";\r\n            m.msg = \"实际功率小于10，忽略不统计\";\r\n            return m;\r\n        } else {\r\n            m.code = \"200\";\r\n            m.msg = \"校验通过\";\r\n            return m;\r\n        }', 'E32', 'E2', 'DAY_ULTRA_SHORT_ACCURACY', NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (100, 'RULES', 1, '        ## 风电：\r\n        ## 短期功率预测：\r\n        ## 情况一：发电功率要大于等于10MW时参与考核，小于10MW时不参与考核，不统计考核点数（包括PMi为零的时候）。\r\n        ## 超短期功率预测：\r\n        ## 和日前功率预测（短期功率预测）考核规则一样。超短期目前考核点位为第一个     * （建议设置可零活配置的点位）\r\n        \r\n        ## 设定返回map\r\n        let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n        ## 如果实际功率为负数，忽略不计\r\n        if (ableValue <0) {\r\n            m.code = \"666\";\r\n            m.msg = \"实际功率为负数，忽略不计\";\r\n            return m;\r\n        }\r\n        ## 如果实际功率或预测功率为空，忽略不计\r\n        if (ableValue == nil || forecastAbleValue == nil) {\r\n            m.code = \"666\";\r\n            m.msg = \"实际或预测为空忽略不统计\";\r\n            return m;\r\n        }\r\n        ## 如果实际功率小于10则不进行计算\r\n        if (ableValue < 10) {\r\n            m.code = \"666\";\r\n            m.msg = \"实际功率小于10，忽略不统计\";\r\n            return m;\r\n        } else {\r\n            m.code = \"200\";\r\n            m.msg = \"校验通过\";\r\n            return m;\r\n        }', 'E33', 'E2', 'DAY_SHORT_ACCURACY', NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (101, 'RULES', 1, '        ## 风电：\r\n        ## 短期功率预测：\r\n        ## 情况一：发电功率要大于等于10MW时参与考核，小于10MW时不参与考核，不统计考核点数（包括PMi为零的时候）。\r\n        ## 超短期功率预测：\r\n        ## 和日前功率预测（短期功率预测）考核规则一样。超短期目前考核点位为第一个     * （建议设置可零活配置的点位）\r\n        \r\n        ## 设定返回map\r\n        let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n        ## 如果实际功率为负数，忽略不计\r\n        if (ableValue <0) {\r\n            m.code = \"666\";\r\n            m.msg = \"实际功率为负数，忽略不计\";\r\n            return m;\r\n        }\r\n        ## 如果实际功率或预测功率为空，忽略不计\r\n        if (ableValue == nil || forecastAbleValue == nil) {\r\n            m.code = \"666\";\r\n            m.msg = \"实际或预测为空忽略不统计\";\r\n            return m;\r\n        }\r\n        ## 如果实际功率小于10则不进行计算\r\n        if (ableValue < 10) {\r\n            m.code = \"666\";\r\n            m.msg = \"实际功率小于10，忽略不统计\";\r\n            return m;\r\n        } else {\r\n            m.code = \"200\";\r\n            m.msg = \"校验通过\";\r\n            return m;\r\n        }', 'E33', 'E2', 'DAY_ULTRA_SHORT_ACCURACY', NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (102, 'RULES', 1, '        ## 风电：\r\n        ## 短期功率预测：\r\n        ## 情况一：发电功率要大于等于10MW时参与考核，小于10MW时不参与考核，不统计考核点数（包括PMi为零的时候）。\r\n        ## 超短期功率预测：\r\n        ## 和日前功率预测（短期功率预测）考核规则一样。超短期目前考核点位为第一个     * （建议设置可零活配置的点位）\r\n        \r\n        ## 设定返回map\r\n        let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n        ## 如果实际功率为负数，忽略不计\r\n        if (ableValue <0) {\r\n            m.code = \"666\";\r\n            m.msg = \"实际功率为负数，忽略不计\";\r\n            return m;\r\n        }\r\n        ## 如果实际功率或预测功率为空，忽略不计\r\n        if (ableValue == nil || forecastAbleValue == nil) {\r\n            m.code = \"666\";\r\n            m.msg = \"实际或预测为空忽略不统计\";\r\n            return m;\r\n        }\r\n        ## 如果实际功率小于10则不进行计算\r\n        if (ableValue < 10) {\r\n            m.code = \"666\";\r\n            m.msg = \"实际功率小于10，忽略不统计\";\r\n            return m;\r\n        } else {\r\n            m.code = \"200\";\r\n            m.msg = \"校验通过\";\r\n            return m;\r\n        }', 'E34', 'E2', 'DAY_SHORT_ACCURACY', NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (103, 'RULES', 1, '        ## 风电：\r\n        ## 短期功率预测：\r\n        ## 情况一：发电功率要大于等于10MW时参与考核，小于10MW时不参与考核，不统计考核点数（包括PMi为零的时候）。\r\n        ## 超短期功率预测：\r\n        ## 和日前功率预测（短期功率预测）考核规则一样。超短期目前考核点位为第一个     * （建议设置可零活配置的点位）\r\n        \r\n        ## 设定返回map\r\n        let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n        ## 如果实际功率为负数，忽略不计\r\n        if (ableValue <0) {\r\n            m.code = \"666\";\r\n            m.msg = \"实际功率为负数，忽略不计\";\r\n            return m;\r\n        }\r\n        ## 如果实际功率或预测功率为空，忽略不计\r\n        if (ableValue == nil || forecastAbleValue == nil) {\r\n            m.code = \"666\";\r\n            m.msg = \"实际或预测为空忽略不统计\";\r\n            return m;\r\n        }\r\n        ## 如果实际功率小于10则不进行计算\r\n        if (ableValue < 10) {\r\n            m.code = \"666\";\r\n            m.msg = \"实际功率小于10，忽略不统计\";\r\n            return m;\r\n        } else {\r\n            m.code = \"200\";\r\n            m.msg = \"校验通过\";\r\n            return m;\r\n        }', 'E34', 'E2', 'DAY_ULTRA_SHORT_ACCURACY', NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (104, 'RULES', 1, '    ## 设定返回map\r\n    let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    ## 如果实际功率为负数，忽略不计\r\n    if (ableValue <0) {\r\n      m.code = \"666\";\r\n      m.msg = \"实际功率为负数，忽略不计\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E36', 'E1', 'DAY_SHORT_ACCURACY', NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (105, 'RULES', 1, '    ## 设定返回map\r\n    let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    ## 如果实际功率为负数，忽略不计\r\n    if (ableValue <0) {\r\n      m.code = \"666\";\r\n      m.msg = \"实际功率为负数，忽略不计\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E36', 'E1', 'DAY_ULTRA_SHORT_ACCURACY', NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (106, 'RULES', 1, '    ## 设定返回map\r\n    let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    ## 如果实际功率为负数，忽略不计\r\n    if (ableValue <0) {\r\n      m.code = \"666\";\r\n      m.msg = \"实际功率为负数，忽略不计\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E36', 'E2', 'DAY_SHORT_ACCURACY', NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (107, 'RULES', 1, '    ## 设定返回map\r\n    let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    ## 如果实际功率为负数，忽略不计\r\n    if (ableValue <0) {\r\n      m.code = \"666\";\r\n      m.msg = \"实际功率为负数，忽略不计\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E36', 'E2', 'DAY_ULTRA_SHORT_ACCURACY', NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (108, 'RULES', 1, '    ## 设定返回map\r\n    let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    ## 如果实际功率为负数，忽略不计\r\n    if (ableValue <0) {\r\n      m.code = \"666\";\r\n      m.msg = \"实际功率为负数，忽略不计\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E37', 'E2', 'DAY_SHORT_ACCURACY', NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (109, 'RULES', 1, '    ## 设定返回map\r\n    let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    ## 如果实际功率为负数，忽略不计\r\n    if (ableValue <0) {\r\n      m.code = \"666\";\r\n      m.msg = \"实际功率为负数，忽略不计\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E37', 'E2', 'DAY_ULTRA_SHORT_ACCURACY', NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (110, 'RULES', 1, '    ## 设定返回map\r\n    let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    ## 如果实际功率为负数，忽略不计\r\n    if (ableValue <0) {\r\n      m.code = \"666\";\r\n      m.msg = \"实际功率为负数，忽略不计\";\r\n      return m;\r\n    }\r\n    ## 如果开机容量为负数，忽略不计\r\n    if (openCapacity <0) {\r\n      m.code = \"666\";\r\n      m.msg = \"开机容量为负数，忽略不计\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E41', 'E2', 'DAY_SHORT_ACCURACY', NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (111, 'RULES', 1, '    ## 设定返回map\r\n    let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    ## 如果实际功率为负数，忽略不计\r\n    if (ableValue <0) {\r\n      m.code = \"666\";\r\n      m.msg = \"实际功率为负数，忽略不计\";\r\n      return m;\r\n    }\r\n    ## 如果开机容量为负数，忽略不计\r\n    if (openCapacity <0) {\r\n      m.code = \"666\";\r\n      m.msg = \"开机容量为负数，忽略不计\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E41', 'E2', 'DAY_ULTRA_SHORT_ACCURACY', NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (112, 'RULES', 1, '    ## 设定返回map\r\n    let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    ## 如果实际功率为负数，忽略不计\r\n    if (ableValue <0) {\r\n      m.code = \"666\";\r\n      m.msg = \"实际功率为负数，忽略不计\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E42', 'E1', 'DAY_SHORT_ACCURACY', NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (113, 'RULES', 1, '    ## 设定返回map\r\n    let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    ## 如果实际功率为负数，忽略不计\r\n    if (ableValue <0) {\r\n      m.code = \"666\";\r\n      m.msg = \"实际功率为负数，忽略不计\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E42', 'E1', 'DAY_ULTRA_SHORT_ACCURACY', NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (114, 'RULES', 1, '    ## 设定返回map\r\n    let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    ## 如果实际功率为负数，忽略不计\r\n    if (ableValue <0) {\r\n      m.code = \"666\";\r\n      m.msg = \"实际功率为负数，忽略不计\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E42', 'E2', 'DAY_SHORT_ACCURACY', NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (115, 'RULES', 1, '    ## 设定返回map\r\n    let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    ## 如果实际功率为负数，忽略不计\r\n    if (ableValue <0) {\r\n      m.code = \"666\";\r\n      m.msg = \"实际功率为负数，忽略不计\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E42', 'E2', 'DAY_ULTRA_SHORT_ACCURACY', NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (116, 'RULES', 1, '    ## 设定返回map\r\n    let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    ## 如果实际功率为负数，忽略不计\r\n    if (ableValue <0) {\r\n      m.code = \"666\";\r\n      m.msg = \"实际功率为负数，忽略不计\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E43', 'E1', 'DAY_SHORT_ACCURACY', NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (117, 'RULES', 1, '    ## 设定返回map\r\n    let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    ## 如果实际功率为负数，忽略不计\r\n    if (ableValue <0) {\r\n      m.code = \"666\";\r\n      m.msg = \"实际功率为负数，忽略不计\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E43', 'E1', 'DAY_ULTRA_SHORT_ACCURACY', NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (118, 'RULES', 1, '    ## 设定返回map\r\n    let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    ## 如果实际功率为负数，忽略不计\r\n    if (ableValue <0) {\r\n      m.code = \"666\";\r\n      m.msg = \"实际功率为负数，忽略不计\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E43', 'E2', 'DAY_SHORT_ACCURACY', NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (119, 'RULES', 1, '    ## 设定返回map\r\n    let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    ## 如果实际功率为负数，忽略不计\r\n    if (ableValue <0) {\r\n      m.code = \"666\";\r\n      m.msg = \"实际功率为负数，忽略不计\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E43', 'E2', 'DAY_ULTRA_SHORT_ACCURACY', NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (120, 'RULES', 1, '    ## 设定返回map\r\n    let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    ## 如果实际功率为负数，忽略不计\r\n    if (ableValue <0) {\r\n      m.code = \"666\";\r\n      m.msg = \"实际功率为负数，忽略不计\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E44', 'E2', 'DAY_SHORT_ACCURACY', NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (121, 'RULES', 1, '    ## 设定返回map\r\n    let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    ## 如果实际功率为负数，忽略不计\r\n    if (ableValue <0) {\r\n      m.code = \"666\";\r\n      m.msg = \"实际功率为负数，忽略不计\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E44', 'E2', 'DAY_ULTRA_SHORT_ACCURACY', NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (122, 'RULES', 1, '    ## 设定返回map\r\n    let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    ## 如果实际功率为负数，忽略不计\r\n    if (ableValue <0) {\r\n      m.code = \"666\";\r\n      m.msg = \"实际功率为负数，忽略不计\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E45', 'E2', 'DAY_SHORT_ACCURACY', NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (123, 'RULES', 1, '    ## 设定返回map\r\n    let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    ## 如果实际功率为负数，忽略不计\r\n    if (ableValue <0) {\r\n      m.code = \"666\";\r\n      m.msg = \"实际功率为负数，忽略不计\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E45', 'E2', 'DAY_ULTRA_SHORT_ACCURACY', NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (124, 'RULES', 1, '    ## 设定返回map\r\n    let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    ## 如果实际功率为负数，忽略不计\r\n    if (ableValue <0) {\r\n      m.code = \"666\";\r\n      m.msg = \"实际功率为负数，忽略不计\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E51', 'E1', 'DAY_SHORT_ACCURACY', NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (125, 'RULES', 1, '    ## 设定返回map\r\n    let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    ## 如果实际功率为负数，忽略不计\r\n    if (ableValue <0) {\r\n      m.code = \"666\";\r\n      m.msg = \"实际功率为负数，忽略不计\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E51', 'E1', 'DAY_ULTRA_SHORT_ACCURACY', NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (126, 'RULES', 1, '    ## 设定返回map\r\n    let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    ## 如果实际功率为负数，忽略不计\r\n    if (ableValue <0) {\r\n      m.code = \"666\";\r\n      m.msg = \"实际功率为负数，忽略不计\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E51', 'E2', 'DAY_SHORT_ACCURACY', NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (127, 'RULES', 1, '    ## 设定返回map\r\n    let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    ## 如果实际功率为负数，忽略不计\r\n    if (ableValue <0) {\r\n      m.code = \"666\";\r\n      m.msg = \"实际功率为负数，忽略不计\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E51', 'E2', 'DAY_ULTRA_SHORT_ACCURACY', NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (128, 'RULES', 1, '    ## 设定返回map\r\n    let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    ## 如果实际功率为负数，忽略不计\r\n    if (ableValue <0) {\r\n      m.code = \"666\";\r\n      m.msg = \"实际功率为负数，忽略不计\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E52', 'E2', 'DAY_SHORT_ACCURACY', NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (129, 'RULES', 1, '    ## 设定返回map\r\n    let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    ## 如果实际功率为负数，忽略不计\r\n    if (ableValue <0) {\r\n      m.code = \"666\";\r\n      m.msg = \"实际功率为负数，忽略不计\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E52', 'E2', 'DAY_ULTRA_SHORT_ACCURACY', NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (130, 'RULES', 1, 'let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n\r\nif(forecastAbleValue==0){\r\n      if(ableValue<=electricCapacity*0.03){\r\n        m.msg=\"预测功率为0，实际功率<=容量的3%\";\r\n        m.data = \"不予考核\";\r\n        return m;\r\n      }else{\r\n        m.msg=\"预测功率为0，实际功率>容量的3%\";\r\n        m.data = \"0.00%\";\r\n        return m;\r\n      }\r\n    }else{\r\n      if(ableValue==0){\r\n        if(forecastAbleValue<=electricCapacity*0.03){\r\n          m.msg=\"实际功率为0，预测功率<=容量的3%\";\r\n          m.data = \"不予考核\";\r\n          return m;\r\n        }\r\n      }else{\r\n        m.code=\"200\";\r\n        m.msg=\"校验通过\";\r\n        return m;\r\n      }\r\n    }\r\n    m.code=\"200\";\r\n    m.msg=\"校验通过\";\r\n    return m;', 'E61', 'E2', 'POINT_SHORT_ACCURACY', NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (131, 'RULES', 1, 'let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n\r\nif(ableValue<=electricCapacity*0.03 && forecastAbleValue<=electricCapacity*0.03){\r\n      m.code = \"666\";\r\n      m.msg = \"实际和预测值均在装机容量3%以内时，忽略不计\";\r\n      return m;\r\n    }\r\n    m.code=\"200\";\r\n    m.msg=\"校验通过\";\r\n    return m;', 'E61', 'E2', 'POINT_ULTRA_SHORT_ACCURACY', NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (132, 'RULES', 1, '    ## 设定返回map\r\n    let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    ## 如果开机容量为负数，忽略不计\r\n    if (openCapacity <=0) {\r\n      m.code = \"666\";\r\n      m.msg = \"开机容量为负数，忽略不计\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m ;', 'E61', 'E2', 'POINT_SHORT_PASS', NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (133, 'RULES', 1, 'let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n\r\nif(ableValue<=electricCapacity*0.03 && forecastAbleValue<=electricCapacity*0.03){\r\n      m.code = \"666\";\r\n      m.msg = \"实际和预测值均在装机容量3%以内时，忽略不计\";\r\n      return m;\r\n    }\r\n    m.code=\"200\";\r\n    m.msg=\"校验通过\";\r\n    return m;', 'E61', 'E2', 'POINT_ULTRA_SHORT_PASS', NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (134, 'RULES', 1, '    ## 光伏：\r\n    ## 短期功率预测：\r\n    ## 情况一：白天11：00—14:00不管发电功率多少都参与考核包含11:00和14:00整点时刻（此期间实际功率若为零，则实际功率按照0.01MW计算），\r\n    ## 其余时间发电功率需要大于等于10MW时参与考核，小于10MW时不参与考核，不统计入考核点数（包括PMi为零的时候）；\r\n    ## 超短期功率预测：\r\n    ## 和日前功率预测（短期功率预测）考核规则一样。超短期目前考核点位为第一个（建议设置可零活配置的点位）。\r\n    let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0%\");\r\n    ## 如果实际功率为负数，忽略不计\r\n    if(ableValue<0){\r\n      m.code=\"666\";\r\n      m.msg=\"实际功率为负数，忽略不计\";\r\n      return m;\r\n    }\r\n    ## 获取当天0时时间戳\r\n    let beginOfDay = getBeginOfDay();\r\n    ## 获取当天11点的时间戳\r\n    let eleven = beginOfDay + 39600000;\r\n    ## 获取当天14点的时间戳\r\n    let fourteen = beginOfDay + 50400000;\r\n    ## 如果实际功率或预测功率为空，忽略不计\r\n    if (ableValue == nil || forecastAbleValue == nil ) {\r\n      m.code = \"666\";\r\n      m.msg = \"忽略不统计\";\r\n      return m;\r\n    }\r\n    ## 如果在11点-14点之间\r\n    if(time>=eleven && time<=fourteen){\r\n    ## 如果实际功率=0，则赋值为0.01\r\n    if(ableValue==0){\r\n      ableValue=0.01M;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;\r\n    }else{\r\n      ## 不在在11点-14点之间，实际功率小于10则忽略不计\r\n      if(ableValue<10M){\r\n        m.code = \"666\";\r\n        m.msg = \"忽略不统计\";\r\n        return m;\r\n      }else{\r\n        m.code = \"200\";\r\n        m.msg = \"校验通过\";\r\n        return m;\r\n      }\r\n    }', 'E32', 'E1', 'DAY_SHORT_ACCURACY', NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (135, 'RULES', 1, '    ## 光伏：\r\n    ## 短期功率预测：\r\n    ## 情况一：白天11：00—14:00不管发电功率多少都参与考核包含11:00和14:00整点时刻（此期间实际功率若为零，则实际功率按照0.01MW计算），\r\n    ## 其余时间发电功率需要大于等于10MW时参与考核，小于10MW时不参与考核，不统计入考核点数（包括PMi为零的时候）；\r\n    ## 超短期功率预测：\r\n    ## 和日前功率预测（短期功率预测）考核规则一样。超短期目前考核点位为第一个（建议设置可零活配置的点位）。\r\n    let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    ## 如果实际功率为负数，忽略不计\r\n    if(ableValue<0){\r\n      m.code=\"666\";\r\n      m.msg=\"实际功率为负数，忽略不计\";\r\n      return m;\r\n    }\r\n    ## 获取当天0时时间戳\r\n    let beginOfDay = getBeginOfDay();\r\n    ## 获取当天11点的时间戳\r\n    let eleven = beginOfDay + 39600000;\r\n    ## 获取当天14点的时间戳\r\n    let fourteen = beginOfDay + 50400000;\r\n    ## 如果实际功率或预测功率为空，忽略不计\r\n    if (ableValue == nil || forecastAbleValue == nil ) {\r\n      m.code = \"666\";\r\n      m.msg = \"忽略不统计\";\r\n      return m;\r\n    }\r\n    ## 如果在11点-14点之间\r\n    if(time>=eleven && time<=fourteen){\r\n    ## 如果实际功率=0，则赋值为0.01\r\n    if(ableValue==0){\r\n      ableValue=0.01M;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;\r\n    }else{\r\n      ## 不在在11点-14点之间，实际功率小于10则忽略不计\r\n      if(ableValue<10M){\r\n        m.code = \"666\";\r\n        m.msg = \"忽略不统计\";\r\n        return m;\r\n      }else{\r\n        m.code = \"200\";\r\n        m.msg = \"校验通过\";\r\n        return m;\r\n      }\r\n    }', 'E32', 'E1', 'DAY_ULTRA_SHORT_ACCURACY', NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (136, 'RULES', 1, '    ## 光伏：\r\n    ## 短期功率预测：\r\n    ## 情况一：白天11：00—14:00不管发电功率多少都参与考核包含11:00和14:00整点时刻（此期间实际功率若为零，则实际功率按照0.01MW计算），\r\n    ## 其余时间发电功率需要大于等于10MW时参与考核，小于10MW时不参与考核，不统计入考核点数（包括PMi为零的时候）；\r\n    ## 超短期功率预测：\r\n    ## 和日前功率预测（短期功率预测）考核规则一样。超短期目前考核点位为第一个（建议设置可零活配置的点位）。\r\n    let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    ## 如果实际功率为负数，忽略不计\r\n    if(ableValue<0){\r\n      m.code=\"666\";\r\n      m.msg=\"实际功率为负数，忽略不计\";\r\n      return m;\r\n    }\r\n    ## 获取当天0时时间戳\r\n    let beginOfDay = getBeginOfDay();\r\n    ## 获取当天11点的时间戳\r\n    let eleven = beginOfDay + 39600000;\r\n    ## 获取当天14点的时间戳\r\n    let fourteen = beginOfDay + 50400000;\r\n    ## 如果实际功率或预测功率为空，忽略不计\r\n    if (ableValue == nil || forecastAbleValue == nil ) {\r\n      m.code = \"666\";\r\n      m.msg = \"忽略不统计\";\r\n      return m;\r\n    }\r\n    ## 如果在11点-14点之间\r\n    if(time>=eleven && time<=fourteen){\r\n    ## 如果实际功率=0，则赋值为0.01\r\n    if(ableValue==0){\r\n      ableValue=0.01M;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;\r\n    }else{\r\n      ## 不在在11点-14点之间，实际功率小于10则忽略不计\r\n      if(ableValue<10M){\r\n        m.code = \"666\";\r\n        m.msg = \"忽略不统计\";\r\n        return m;\r\n      }else{\r\n        m.code = \"200\";\r\n        m.msg = \"校验通过\";\r\n        return m;\r\n      }\r\n    }', 'E33', 'E1', 'DAY_SHORT_ACCURACY', NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (137, 'RULES', 1, '    ## 光伏：\r\n    ## 短期功率预测：\r\n    ## 情况一：白天11：00—14:00不管发电功率多少都参与考核包含11:00和14:00整点时刻（此期间实际功率若为零，则实际功率按照0.01MW计算），\r\n    ## 其余时间发电功率需要大于等于10MW时参与考核，小于10MW时不参与考核，不统计入考核点数（包括PMi为零的时候）；\r\n    ## 超短期功率预测：\r\n    ## 和日前功率预测（短期功率预测）考核规则一样。超短期目前考核点位为第一个（建议设置可零活配置的点位）。\r\n    let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    ## 如果实际功率为负数，忽略不计\r\n    if(ableValue<0){\r\n      m.code=\"666\";\r\n      m.msg=\"实际功率为负数，忽略不计\";\r\n      return m;\r\n    }\r\n    ## 获取当天0时时间戳\r\n    let beginOfDay = getBeginOfDay();\r\n    ## 获取当天11点的时间戳\r\n    let eleven = beginOfDay + 39600000;\r\n    ## 获取当天14点的时间戳\r\n    let fourteen = beginOfDay + 50400000;\r\n    ## 如果实际功率或预测功率为空，忽略不计\r\n    if (ableValue == nil || forecastAbleValue == nil ) {\r\n      m.code = \"666\";\r\n      m.msg = \"忽略不统计\";\r\n      return m;\r\n    }\r\n    ## 如果在11点-14点之间\r\n    if(time>=eleven && time<=fourteen){\r\n    ## 如果实际功率=0，则赋值为0.01\r\n    if(ableValue==0){\r\n      ableValue=0.01M;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;\r\n    }else{\r\n      ## 不在在11点-14点之间，实际功率小于10则忽略不计\r\n      if(ableValue<10M){\r\n        m.code = \"666\";\r\n        m.msg = \"忽略不统计\";\r\n        return m;\r\n      }else{\r\n        m.code = \"200\";\r\n        m.msg = \"校验通过\";\r\n        return m;\r\n      }\r\n    }', 'E33', 'E1', 'DAY_ULTRA_SHORT_ACCURACY', NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (138, 'RULES', 1, '    ## 光伏：\r\n    ## 短期功率预测：\r\n    ## 情况一：白天11：00—14:00不管发电功率多少都参与考核包含11:00和14:00整点时刻（此期间实际功率若为零，则实际功率按照0.01MW计算），\r\n    ## 其余时间发电功率需要大于等于10MW时参与考核，小于10MW时不参与考核，不统计入考核点数（包括PMi为零的时候）；\r\n    ## 超短期功率预测：\r\n    ## 和日前功率预测（短期功率预测）考核规则一样。超短期目前考核点位为第一个（建议设置可零活配置的点位）。\r\n    let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    ## 如果实际功率为负数，忽略不计\r\n    if(ableValue<0){\r\n      m.code=\"666\";\r\n      m.msg=\"实际功率为负数，忽略不计\";\r\n      return m;\r\n    }\r\n    ## 获取当天0时时间戳\r\n    let beginOfDay = getBeginOfDay();\r\n    ## 获取当天11点的时间戳\r\n    let eleven = beginOfDay + 39600000;\r\n    ## 获取当天14点的时间戳\r\n    let fourteen = beginOfDay + 50400000;\r\n    ## 如果实际功率或预测功率为空，忽略不计\r\n    if (ableValue == nil || forecastAbleValue == nil ) {\r\n      m.code = \"666\";\r\n      m.msg = \"忽略不统计\";\r\n      return m;\r\n    }\r\n    ## 如果在11点-14点之间\r\n    if(time>=eleven && time<=fourteen){\r\n    ## 如果实际功率=0，则赋值为0.01\r\n    if(ableValue==0){\r\n      ableValue=0.01M;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;\r\n    }else{\r\n      ## 不在在11点-14点之间，实际功率小于10则忽略不计\r\n      if(ableValue<10M){\r\n        m.code = \"666\";\r\n        m.msg = \"忽略不统计\";\r\n        return m;\r\n      }else{\r\n        m.code = \"200\";\r\n        m.msg = \"校验通过\";\r\n        return m;\r\n      }\r\n    }', 'E34', 'E1', 'DAY_SHORT_ACCURACY', NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (139, 'RULES', 1, '    ## 光伏：\r\n    ## 短期功率预测：\r\n    ## 情况一：白天11：00—14:00不管发电功率多少都参与考核包含11:00和14:00整点时刻（此期间实际功率若为零，则实际功率按照0.01MW计算），\r\n    ## 其余时间发电功率需要大于等于10MW时参与考核，小于10MW时不参与考核，不统计入考核点数（包括PMi为零的时候）；\r\n    ## 超短期功率预测：\r\n    ## 和日前功率预测（短期功率预测）考核规则一样。超短期目前考核点位为第一个（建议设置可零活配置的点位）。\r\n    let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    ## 如果实际功率为负数，忽略不计\r\n    if(ableValue<0){\r\n      m.code=\"666\";\r\n      m.msg=\"实际功率为负数，忽略不计\";\r\n      return m;\r\n    }\r\n    ## 获取当天0时时间戳\r\n    let beginOfDay = getBeginOfDay();\r\n    ## 获取当天11点的时间戳\r\n    let eleven = beginOfDay + 39600000;\r\n    ## 获取当天14点的时间戳\r\n    let fourteen = beginOfDay + 50400000;\r\n    ## 如果实际功率或预测功率为空，忽略不计\r\n    if (ableValue == nil || forecastAbleValue == nil ) {\r\n      m.code = \"666\";\r\n      m.msg = \"忽略不统计\";\r\n      return m;\r\n    }\r\n    ## 如果在11点-14点之间\r\n    if(time>=eleven && time<=fourteen){\r\n    ## 如果实际功率=0，则赋值为0.01\r\n    if(ableValue==0){\r\n      ableValue=0.01M;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;\r\n    }else{\r\n      ## 不在在11点-14点之间，实际功率小于10则忽略不计\r\n      if(ableValue<10M){\r\n        m.code = \"666\";\r\n        m.msg = \"忽略不统计\";\r\n        return m;\r\n      }else{\r\n        m.code = \"200\";\r\n        m.msg = \"校验通过\";\r\n        return m;\r\n      }\r\n    }', 'E34', 'E1', 'DAY_ULTRA_SHORT_ACCURACY', NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (140, 'RULES', 1, '    ## 设定返回map\r\n    let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    ## 如果开机容量为负数，忽略不计\r\n    if (openCapacity <=0) {\r\n      m.code = \"666\";\r\n      m.msg = \"开机容量为负数，忽略不计\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m ;', 'E21', 'E2', 'DAY_SHORT_ACCURACY', NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (141, 'RULES', 1, '    ## 设定返回map\r\n    let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    ## 如果开机容量为负数，忽略不计\r\n    if (openCapacity <=0) {\r\n      m.code = \"666\";\r\n      m.msg = \"开机容量为负数，忽略不计\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m ;', 'E21', 'E2', 'DAY_ULTRA_SHORT_ACCURACY', NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (142, 'RULES', 1, '    ## 设定返回map\r\n    let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    ## 如果开机容量为负数，忽略不计\r\n    if (openCapacity <=0) {\r\n      m.code = \"666\";\r\n      m.msg = \"开机容量为负数，忽略不计\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m ;', 'E22', 'E2', 'DAY_SHORT_ACCURACY', NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (143, 'RULES', 1, '    ## 设定返回map\r\n    let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    ## 如果开机容量为负数，忽略不计\r\n    if (openCapacity <=0) {\r\n      m.code = \"666\";\r\n      m.msg = \"开机容量为负数，忽略不计\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m ;', 'E22', 'E2', 'DAY_ULTRA_SHORT_ACCURACY', NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (144, 'RULES', 1, '    ## 设定返回map\r\n    let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    ## 如果开机容量为负数，忽略不计\r\n    if (openCapacity <=0) {\r\n      m.code = \"666\";\r\n      m.msg = \"开机容量为负数，忽略不计\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m ;', 'E23', 'E2', 'DAY_SHORT_ACCURACY', NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (145, 'RULES', 1, '    ## 设定返回map\r\n    let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    ## 如果开机容量为负数，忽略不计\r\n    if (openCapacity <=0) {\r\n      m.code = \"666\";\r\n      m.msg = \"开机容量为负数，忽略不计\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m ;', 'E23', 'E2', 'DAY_ULTRA_SHORT_ACCURACY', NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (146, 'RULES', 1, '    ## 设定返回map\r\n    let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    ## 如果实际功率为负数，忽略不计\r\n    if (ableValue <0) {\r\n      m.code = \"666\";\r\n      m.msg = \"实际功率为负数，忽略不计\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E12', 'E2', 'DAY_SHORT_ACCURACY', NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (147, 'RULES', 1, '    ## 设定返回map\r\n    let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    ## 如果实际功率为负数，忽略不计\r\n    if (ableValue <0) {\r\n      m.code = \"666\";\r\n      m.msg = \"实际功率为负数，忽略不计\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E12', 'E2', 'DAY_ULTRA_SHORT_ACCURACY', NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (148, 'RULES', 1, '    ## 设定返回map\r\n    let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    ## 如果实际功率为负数，忽略不计\r\n    if (ableValue <0) {\r\n      m.code = \"666\";\r\n      m.msg = \"实际功率为负数，忽略不计\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E13', 'E2', 'DAY_SHORT_ACCURACY', NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (149, 'RULES', 1, '    ## 设定返回map\r\n    let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    ## 如果实际功率为负数，忽略不计\r\n    if (ableValue <0) {\r\n      m.code = \"666\";\r\n      m.msg = \"实际功率为负数，忽略不计\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E13', 'E2', 'DAY_ULTRA_SHORT_ACCURACY', NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (150, 'DAY_SHORT_PASS', 1, 'return \'100.00%\';', 'E42', 'E1', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (151, 'DAY_ULTRA_SHORT_PASS', 1, 'return \'100.00%\';', 'E42', 'E1', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (152, 'DAY_SHORT_PASS', 1, 'return \'100.00%\';', 'E42', 'E2', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (153, 'DAY_ULTRA_SHORT_PASS', 1, 'return \'100.00%\';', 'E42', 'E2', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (154, 'DAY_SHORT_ACCURACY', 1, 'rootMeanSquaredErrorC(list,ableValue,forecastAbleValue,openCapacity)', 'E61', 'E2', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (155, 'DAY_ULTRA_SHORT_ACCURACY', 1, 'rootMeanSquaredErrorC(list,ableValue,forecastAbleValue,openCapacity)', 'E61', 'E2', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (156, 'DAY_SHORT_PASS', 1, 'pass(list,(electricCapacity*0.03),ableValue,forecastAbleValue,openCapacity)', 'E61', 'E2', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (157, 'DAY_ULTRA_SHORT_PASS', 1, 'pass(list,(electricCapacity*0.03),ableValue,forecastAbleValue,openCapacity)', 'E61', 'E2', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (158, 'POINT_SHORT_PASS', 1, 'pass(list,(electricCapacity*0.03),ableValue,forecastAbleValue,openCapacity)', 'E63', 'E2', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (159, 'POINT_ULTRA_SHORT_PASS', 1, 'pass(list,(electricCapacity*0.03),ableValue,forecastAbleValue,openCapacity)', 'E63', 'E2', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (160, 'DAY_SHORT_ACCURACY', 1, 'rootMeanSquaredErrorC(list,ableValue,forecastAbleValue,openCapacity)', 'E63', 'E2', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (161, 'DAY_ULTRA_SHORT_ACCURACY', 1, 'rootMeanSquaredErrorC(list,ableValue,forecastAbleValue,openCapacity)', 'E63', 'E2', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (162, 'DAY_SHORT_PASS', 1, 'pass(list,(electricCapacity*0.03),ableValue,forecastAbleValue,openCapacity)', 'E63', 'E2', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (163, 'DAY_ULTRA_SHORT_PASS', 1, 'pass(list,(electricCapacity*0.03),ableValue,forecastAbleValue,openCapacity)', 'E63', 'E2', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (164, 'RULES', 1, 'let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    if(forecastAbleValue==0){\r\n        if(ableValue<=electricCapacity*0.03){\r\n            m.msg=\"预测功率为0，实际功率<=容量的3%\";\r\n            m.data = \"不予考核\";\r\n            return m;\r\n        }else{\r\n            m.msg=\"预测功率为0，实际功率>容量的3%\";\r\n            m.data = \"0.00%\";\r\n            return m;\r\n        }\r\n    }else{\r\n        if(ableValue==0){\r\n                if(forecastAbleValue<=electricCapacity*0.03){\r\n                    m.msg=\"实际功率为0，预测功率<=容量的3%\";\r\n                    m.data = \"不予考核\";\r\n                    return m;\r\n                }else{\r\n                    m.msg=\"实际功率为0，预测功率>容量的3%\";\r\n                    m.data = \"0.00%\";\r\n                    return m;\r\n                }\r\n            }\r\n    }\r\n    m.code=\"200\";\r\n    m.msg=\"校验通过\";\r\n    return m;', 'E63', 'E2', 'POINT_SHORT_ACCURACY', NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (165, 'RULES', 1, 'let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n\r\nif(ableValue<=electricCapacity*0.03 && forecastAbleValue<=electricCapacity*0.03){\r\n      m.code = \"666\";\r\n      m.msg = \"实际和预测值均在装机容量3%以内时，忽略不计\";\r\n      return m;\r\n    }\r\n    m.code=\"200\";\r\n    m.msg=\"校验通过\";\r\n    return m;', 'E63', 'E2', 'POINT_ULTRA_SHORT_ACCURACY', NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (166, 'RULES', 1, '    ## 设定返回map\r\n    let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    ## 如果开机容量为负数，忽略不计\r\n    if (openCapacity <=0) {\r\n      m.code = \"666\";\r\n      m.msg = \"开机容量为负数，忽略不计\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m ;', 'E63', 'E2', 'POINT_SHORT_PASS', NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (167, 'RULES', 1, 'let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n\r\nif(ableValue<=electricCapacity*0.03 && forecastAbleValue<=electricCapacity*0.03){\r\n      m.code = \"666\";\r\n      m.msg = \"实际和预测值均在装机容量3%以内时，忽略不计\";\r\n      return m;\r\n    }\r\n    m.code=\"200\";\r\n    m.msg=\"校验通过\";\r\n    return m;', 'E63', 'E2', 'POINT_ULTRA_SHORT_PASS', NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (168, 'RULES', 1, 'let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    if(forecastAbleValue==0){\r\n        if(ableValue<=electricCapacity*0.03){\r\n            m.msg=\"预测功率为0，实际功率<=容量的3%\";\r\n            m.data = \"不予考核\";\r\n            return m;\r\n        }else{\r\n            m.msg=\"预测功率为0，实际功率>容量的3%\";\r\n            m.data = \"0.00%\";\r\n            return m;\r\n        }\r\n    }else{\r\n        if(ableValue==0){\r\n                if(forecastAbleValue<=electricCapacity*0.03){\r\n                    m.msg=\"实际功率为0，预测功率<=容量的3%\";\r\n                    m.data = \"不予考核\";\r\n                    return m;\r\n                }else{\r\n                    m.msg=\"实际功率为0，预测功率>容量的3%\";\r\n                    m.data = \"0.00%\";\r\n                    return m;\r\n                }\r\n            }\r\n    }\r\n    m.code=\"200\";\r\n    m.msg=\"校验通过\";\r\n    return m;', 'E64', 'E2', 'POINT_SHORT_ACCURACY', NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (169, 'RULES', 1, 'let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n\r\nif(ableValue<=electricCapacity*0.03 && forecastAbleValue<=electricCapacity*0.03){\r\n      m.code = \"666\";\r\n      m.msg = \"实际和预测值均在装机容量3%以内时，忽略不计\";\r\n      return m;\r\n    }\r\n    m.code=\"200\";\r\n    m.msg=\"校验通过\";\r\n    return m;', 'E64', 'E2', 'POINT_ULTRA_SHORT_ACCURACY', NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (170, 'RULES', 1, '    ## 设定返回map\r\n    let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    ## 如果开机容量为负数，忽略不计\r\n    if (openCapacity <=0) {\r\n      m.code = \"666\";\r\n      m.msg = \"开机容量为负数，忽略不计\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m ;', 'E64', 'E2', 'POINT_SHORT_PASS', NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (171, 'RULES', 1, 'let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n\r\nif(ableValue<=electricCapacity*0.03 && forecastAbleValue<=electricCapacity*0.03){\r\n      m.code = \"666\";\r\n      m.msg = \"实际和预测值均在装机容量3%以内时，忽略不计\";\r\n      return m;\r\n    }\r\n    m.code=\"200\";\r\n    m.msg=\"校验通过\";\r\n    return m;', 'E64', 'E2', 'POINT_ULTRA_SHORT_PASS', NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (172, 'RULES', 1, 'let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    if(forecastAbleValue==0){\r\n        if(ableValue<=electricCapacity*0.03){\r\n            m.msg=\"预测功率为0，实际功率<=容量的3%\";\r\n            m.data = \"不予考核\";\r\n            return m;\r\n        }else{\r\n            m.msg=\"预测功率为0，实际功率>容量的3%\";\r\n            m.data = \"0.00%\";\r\n            return m;\r\n        }\r\n    }else{\r\n        if(ableValue==0){\r\n                if(forecastAbleValue<=electricCapacity*0.03){\r\n                    m.msg=\"实际功率为0，预测功率<=容量的3%\";\r\n                    m.data = \"不予考核\";\r\n                    return m;\r\n                }else{\r\n                    m.msg=\"实际功率为0，预测功率>容量的3%\";\r\n                    m.data = \"0.00%\";\r\n                    return m;\r\n                }\r\n            }\r\n    }\r\n    m.code=\"200\";\r\n    m.msg=\"校验通过\";\r\n    return m;', 'E65', 'E2', 'POINT_SHORT_ACCURACY', NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (173, 'RULES', 1, 'let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n\r\nif(ableValue<=electricCapacity*0.03 && forecastAbleValue<=electricCapacity*0.03){\r\n      m.code = \"666\";\r\n      m.msg = \"实际和预测值均在装机容量3%以内时，忽略不计\";\r\n      return m;\r\n    }\r\n    m.code=\"200\";\r\n    m.msg=\"校验通过\";\r\n    return m;', 'E65', 'E2', 'POINT_ULTRA_SHORT_ACCURACY', NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (174, 'RULES', 1, '    ## 设定返回map\r\n    let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    ## 如果开机容量为负数，忽略不计\r\n    if (openCapacity <=0) {\r\n      m.code = \"666\";\r\n      m.msg = \"开机容量为负数，忽略不计\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m ;', 'E65', 'E2', 'POINT_SHORT_PASS', NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (175, 'RULES', 1, 'let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n\r\nif(ableValue<=electricCapacity*0.03 && forecastAbleValue<=electricCapacity*0.03){\r\n      m.code = \"666\";\r\n      m.msg = \"实际和预测值均在装机容量3%以内时，忽略不计\";\r\n      return m;\r\n    }\r\n    m.code=\"200\";\r\n    m.msg=\"校验通过\";\r\n    return m;', 'E65', 'E2', 'POINT_ULTRA_SHORT_PASS', NULL, NULL, NULL, NULL, NULL);

SET FOREIGN_KEY_CHECKS = 1;
